Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.mule.api.client
Interface MuleClient

All Known Subinterfaces:
  LocalMuleClient

All Known Implementing Classes:
  DefaultLocalMuleClient

    public interface MuleClient

Provides methods for performing send, dispatch and request operations programatically.

Method Summary
`void` | `dispatch(String url, MuleMessage message)` Dispatches an event asynchronously to a endpointUri via a Mule server.
`void` | `dispatch(String url, Object payload, Map<String,Object> messageProperties)` Dispatches an event asynchronously to a endpointUri via a Mule server.
`MuleMessage` | `process(String uri, MessageExchangePattern mep, MuleMessage message)` Processes a messsage with an outbound endpoint using the specified `MessageExchangePattern`
`MuleMessage` | `process(String uri, MessageExchangePattern mep, Object payload, Map<String,Object> messageProperties)` Processes a message with an outbound endpoint using the specified `MessageExchangePattern`
`MuleMessage` | `request(String url, long timeout)` Will receive an event from an endpointUri determined by the URL.
`MuleMessage` | `send(String url, MuleMessage message)` Sends an event synchronously to a endpointUri via a Mule server and a resulting message is returned.
`MuleMessage` | `send(String url, MuleMessage message, long timeout)` Sends an event synchronously to a endpointUri via a mule server and a resulting message is returned.
`MuleMessage` | `send(String url, Object payload, Map<String,Object> messageProperties)` Sends an event synchronously to a endpointUri via a Mule server and a resulting message is returned.
`MuleMessage` | `send(String url, Object payload, Map<String,Object> messageProperties, long timeout)` Sends an event synchronously to a endpointUri via a mule server and a resulting message is returned.

Method Detail

### dispatch

    void dispatch(String url,
                  Object payload,
                  Map<String,Object> messageProperties)
                  throws MuleException

  Dispatches an event asynchronously to a endpointUri via a Mule server. The URL determines where to dispatch the event to.

  Parameters:
    `url` - the Mule URL used to determine the destination and transport of the message
    `payload` - the object that is the payload of the event
    `messageProperties` - any properties to be associated with the payload. In the case of JMS you could set the JMSReplyTo property in these properties.
  Throws:
    `MuleException`

### dispatch

    void dispatch(String url,
                  MuleMessage message)
                  throws MuleException

  Dispatches an event asynchronously to a endpointUri via a Mule server. The URL determines where to dispatch the event to.

  Parameters:
    `url` - the Mule URL used to determine the destination and transport of the message
    `message` - the message to send
  Throws:
    `MuleException`

### send

    MuleMessage send(String url,
                     Object payload,
                     Map<String,Object> messageProperties)
                     throws MuleException

  Sends an event synchronously to a endpointUri via a Mule server and a resulting message is returned.

  Parameters:
    `url` - the Mule URL used to determine the destination and transport of the message
    `payload` - the object that is the payload of the event
    `messageProperties` - any properties to be associated with the payload. In the case of Jms you could set the JMSReplyTo property in these properties.
  Returns:
    A return message, this could be `null` if the the components invoked explicitly sets a return as `null`.
  Throws:
    `MuleException`

### send

    MuleMessage send(String url,
                     MuleMessage message)
                     throws MuleException

  Sends an event synchronously to a endpointUri via a Mule server and a resulting message is returned.

  Parameters:
    `url` - the Mule URL used to determine the destination and transport of the message
    `message` - the Message for the event
  Returns:
    A return message, this could be `null` if the the components invoked explicitly sets a return as `null`.
  Throws:
    `MuleException`

### send

    MuleMessage send(String url,
                     Object payload,
                     Map<String,Object> messageProperties,
                     long timeout)
                     throws MuleException

  Sends an event synchronously to a endpointUri via a mule server and a resulting message is returned.

  Parameters:
    `url` - the Mule URL used to determine the destination and transport of the message
    `payload` - the object that is the payload of the event
    `messageProperties` - any properties to be associated with the payload. In the case of Jms you could set the JMSReplyTo property in these properties.
    `timeout` - The time in milliseconds the the call should block waiting for a response
  Returns:
    A return message, this could be `null` if the the components invoked explicitly sets a return as `null`.
  Throws:
    `MuleException`

### send

    MuleMessage send(String url,
                     MuleMessage message,
                     long timeout)
                     throws MuleException

  Sends an event synchronously to a endpointUri via a mule server and a resulting message is returned.

  Parameters:
    `url` - the Mule URL used to determine the destination and transport of the message
    `message` - The message to send
    `timeout` - The time in milliseconds the the call should block waiting for a response
  Returns:
    A return message, this could be `null` if the the components invoked explicitly sets a return as `null`.
  Throws:
    `MuleException`

### request

    MuleMessage request(String url,
                        long timeout)
                        throws MuleException

  Will receive an event from an endpointUri determined by the URL.

  Parameters:
    `url` - the Mule URL used to determine the destination and transport of the message
    `timeout` - how long to block waiting to receive the event, if set to 0 the receive will not wait at all and if set to -1 the receive will wait forever
  Returns:
    the message received or `null` if no message was received
  Throws:
    `MuleException`

### process

    MuleMessage process(String uri,
                        MessageExchangePattern mep,
                        Object payload,
                        Map<String,Object> messageProperties)
                        throws MuleException

  Processes a message with an outbound endpoint using the specified `MessageExchangePattern`

  Parameters:
    `uri` -
    `mep` - the `MessageExchangePattern` that should be used
    `payload` - the message payload
    `messageProperties` - and message properties that should be used (optional, use null otherwise)
  Returns:
    the result of endpoint invocation if the `MessageExchangePattern` defines a response else null.
  Throws:
    `MuleException`

### process

    MuleMessage process(String uri,
                        MessageExchangePattern mep,
                        MuleMessage message)
                        throws MuleException

  Processes a messsage with an outbound endpoint using the specified `MessageExchangePattern`

  Parameters:
    `uri` -
    `mep` - the `MessageExchangePattern` that should be used
    `message` - the message to be processed
  Returns:
    the result of endpoint invocation if the `MessageExchangePattern` defines a response else null.
  Throws:
    `MuleException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2010 MuleSoft, Inc.. All Rights Reserved.